Debian: update standards to 3.9.1; add libpam0g-dev dependency
[ngircd-alex.git] / contrib / Debian / ngircd.init
1 #!/bin/sh
2 #
3 # ngIRCd start and stop script for Debian-based systems
4 # Copyright 2008-2010 Alexander Barton <alex@barton.de>
5 #
6
7 ### BEGIN INIT INFO
8 # Provides:             ngircd
9 # Required-Start:       $network $remote_fs
10 # Required-Stop:        $network $remote_fs
11 # Should-Start:         $syslog $named
12 # Should-Stop:          $syslog
13 # Default-Start:        2 3 4 5
14 # Default-Stop:         0 1 6
15 # Short-Description:    Next Generation IRC Server
16 # Description:          IRC daemon written from scratch
17 ### END INIT INFO
18
19 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
20 DAEMON=/usr/sbin/ngircd
21 NAME=ngIRCd
22 DESC="IRC daemon"
23 PARAMS=""
24 STARTTIME=1
25 DIETIME=10
26
27 test -x $DAEMON || exit 5
28
29 test -h "$0" && me=`readlink $0` || me="$0"
30 BASENAME=`basename $me`
31
32 test -r /etc/default/$BASENAME && . /etc/default/$BASENAME
33
34 # LSB compatibility functions that become used if there is no local
35 # include file available.
36 log_daemon_msg() {
37         echo -n "$*"
38 }
39 log_end_msg() {
40         [ "$1" == "0" ] && echo "." || echo " failed!"
41 }
42 log_failure_msg() {
43         echo "$*"
44 }
45 log_warning_msg() {
46         log_failure_msg "$*"
47 }
48
49 # Include LSB functions, if available:
50 test -r /lib/lsb/init-functions && . /lib/lsb/init-functions
51
52 PIDFILE=`$DAEMON $PARAMS -t | tr -d ' ' | grep "^PidFile=" | cut -d'=' -f2`
53 [ -n "$PIDFILE" ] || PIDFILE="/var/run/ircd/ngircd.pid"
54
55 r=3
56
57 Check_Config()
58 {
59         # Make sure that the configuration of ngIRCd is valid:
60         $DAEMON $PARAMS --configtest >/dev/null 2>&1
61         [ $? -eq 0 ] && return 0
62         log_end_msg 1
63         log_failure_msg "Configuration of $NAME is not valid, won't (re)start!"
64         log_failure_msg "Run \"$DAEMON --configtest\" and fix it up ..."
65         exit 6
66 }
67
68 Prepare() {
69         # Make sure the PID file directory exists and is writable:
70         user=`$DAEMON $PARAMS -t|tr -d ' '|grep "^ServerUID="|cut -d'=' -f2`
71         group=`$DAEMON $PARAMS -t|tr -d ' '|grep "^ServerGID="|cut -d'=' -f2`
72         piddir=`dirname "$PIDFILE"`
73         [ -d "$piddir" ] || mkdir -p "$piddir" 2>/dev/null
74         chown "$user:$group" "$piddir" 2>/dev/null
75         [ $? -eq 0 ] && return 0
76         log_end_msg 1
77         log_failure_msg "Failed to prepare '$piddir' for user '$user'!"
78         exit 1
79 }
80
81 Do_Start() {
82         if Do_Status; then
83                 log_end_msg 0
84                 log_warning_msg "$NAME seems to be already running, nothing to do."
85                 exit 0
86         fi
87         start-stop-daemon --start \
88                 --quiet --exec $DAEMON -- $PARAMS
89         sleep $STARTTIME
90         Do_Status || return 7
91         return 0
92 }
93
94 Do_Stop() {
95         if ! Do_Status; then
96                 log_end_msg 0
97                 log_warning_msg "$NAME seems not to be running, nothing to do."
98                 exit 0
99         fi
100         Do_ForceStop
101         return $?
102 }
103
104 Do_ForceStop() {
105         [ -e $PIDFILE ] \
106                 && pidfile="--pidfile $PIDFILE" \
107                 || pidfile=""
108         start-stop-daemon --stop \
109                 --quiet --oknodo --exec $DAEMON $pidfile
110         for i in `seq 1 $DIETIME`; do
111                 Do_Status || return 0
112                 sleep 1
113         done
114         return 1
115 }
116
117 Do_Reload() {
118         start-stop-daemon --stop --signal 1 --quiet --exec $DAEMON
119         return $?
120 }
121
122 Do_Status() {
123         [ -e $PIDFILE ] \
124                 && pidfile="--pidfile $PIDFILE" \
125                 || pidfile=""
126         start-stop-daemon --stop \
127                 --quiet --signal 0 --exec $DAEMON $pidfile >/dev/null
128         return $?
129 }
130
131 case "$1" in
132   start)
133         log_daemon_msg "Starting $DESC" "$NAME"
134         Check_Config
135         Prepare
136         Do_Start; r=$?
137         log_end_msg $r
138         ;;
139   stop)
140         log_daemon_msg "Stopping $DESC" "$NAME"
141         Do_Stop; r=$?
142         log_end_msg $r
143         ;;
144   reload|force-reload)
145         log_daemon_msg "Reloading $DESC" "$NAME"
146         Check_Config
147         Do_Reload; r=$?
148         log_end_msg $r
149         ;;
150   restart)
151         log_daemon_msg "Restarting $DESC" "$NAME"
152         Check_Config
153         Prepare
154         Do_ForceStop
155         Do_Start; r=$?
156         log_end_msg $r
157         ;;
158   status)
159         log_daemon_msg "Checking for $DESC" "$NAME"
160         Do_Status; r=$?
161         log_end_msg $r
162         ;;
163   test)
164         Check_Config
165         echo "Configuration of $DAEMON seems to be ok."; r=0
166         ;;
167   *)
168         N=/etc/init.d/$NAME; r=2
169         echo "Usage: $N {start|stop|restart|reload|force-reload|status|test}" >&2
170         ;;
171 esac
172
173 exit $r
174
175 # -eof-